package lawOfDemeter;
import java.util.*;

/**
 * The Supplier class is a  super class for the bin aspects.
 * It provides common functionality around a HashMap (targets)
 * that keeps track of the preferred supplier objects stored in the
 * various bins.
 *
 * @author David H. Lorenz
 * @author Modifications made by Paul Freeman
 */
abstract class Supplier {
	boolean contains(Object target) {
		if (targets.containsKey(target)) {
			System.out.println(" target found " +
			targets.get(target) +" object id " + target.toString());
			return true;
		}
		return false;
	}
	void add(Object target,String i) {
		targets.put(target,i);
	}
	void addAll(Object[] targetlist,String i) {
		for (int k=0; k<targetlist.length; k++)
			add(targetlist[k],i);
	}
	protected String at(org.aspectj.lang.JoinPoint jp) {
		return " at "
			+ jp.getSourceLocation().getFileName() + ":"
			+ jp.getSourceLocation().getLine() + ":"
			+ jp.getSourceLocation().getColumn() + " this "
			+ jp.getThis() + " target "
			+ jp.getTarget();
	}
	protected final static String argument = " OK--Argument";
	protected final static String local    = " OK--New, local, or static";
	protected final static String direct   = " OK--Instance variable";
	protected final static String receiver = " OK--Receiver";

	HashMap targets=new HashMap();
	void printHashMap(HashMap targets) {
//		System.out.println();
		System.out.println(" elements of targets ");
//                Object[] values = targets.values().toArray();
//		for (int k=0; k<values.length; k++)
//			System.out.println(values[k]);
                Object[] keys = targets.keySet().toArray();
		for (int k=0; k<keys.length; k++)
			System.out.println(keys[k]);
		System.out.println(" END elements of targets ");

        }
}
